# [Ajhc](http://ajhc.metasepi.org/) - arafura-jhc

A fork of [jhc](http://repetae.net/computer/jhc/).
And also a Haskell compiler. 

This project is founded by [Metasepi Project](http://metasepi.org/).

## Build Status

* [![Build Status](https://travis-ci.org/ajhc/ajhc.png?branch=arafura)](https://travis-ci.org/ajhc/ajhc) Ubuntu
* [![Build Status](https://travis-ci.org/ajhc/ajhc.png?branch=arafura-ci4osx)](https://travis-ci.org/ajhc/ajhc) Mac OS X

## How to install

    $ sudo apt-get install haskell-platform libncurses5-dev gcc m4
    $ cabal install ajhc

## How to build latest version

    $ sudo apt-get install make locales autoconf haskell-derive-utils \
      libconfig-yaml-perl graphviz haskell-platform cpphs pandoc hscolour po4a \
      libghc-temporary-dev libghc-haskeline-dev libghc-utf8-string-dev libghc-hssyck-dev \
      libghc-test-framework-th-dev libghc-test-framework-hunit-dev \
      libghc-test-framework-quickcheck2-dev libghc-uniplate-dev libgc-dev gcc valgrind
    $ git clone git://github.com/ajhc/ajhc.git
    $ cd ajhc
    $ git checkout arafura
    $ autoreconf -i
    $ ./configure
    $ make
    $ make install

## For developing

First, you should use the arafura branch, rather than master branch.

* [master branch](https://github.com/ajhc/ajhc/tree/master): Do not touch me, mirror of [jhc's darcs repository](http://repetae.net/dw/darcsweb.cgi?r=jhc).
* [arafura branch](https://github.com/ajhc/ajhc/tree/arafura): For developing Ajhc.

You should send patch to jhc, if testing on Ajhc is good.

    $ darcs get http://repetae.net/repos/jhc
    $ cd jhc/
    $ patch -p1 < ~/yourfile.patch
    $ darcs record -a
    $ darcs send

The command [darcs send](http://darcs.net/Using/Send) sends email the patch to
jhc author (= [John Meacham](http://repetae.net/)).

Perhaps you can get internal overview with following compile flow image:

![](https://raw.github.com/ajhc/ajhc/arafura/docs/jhc_compile_flow.png)

## Needing to install/build on Windows (experimental)

### Install msys

http://sourceforge.net/projects/mingw/files/Installer/mingw-get-inst/

Install below.

* C Compiler
* MSYS Basic System
* MinGW Developer ToolKit

You should run cabal install on msys console.

### Install Git for Windows

http://msysgit.github.com/

It's good choosing the below option.

* "Checkout as-is, commit as-is"
* "Run Git and included Unix tools from the Windows Command Prompt"

### Install Haskell Platform

http://www.haskell.org/platform/windows.html

## Future plan

* No more depend on Perl (LWP and YAML).
* Port Haskell libraries on haskell-platform to Ajhc.
* Understand jhc's region inference.
* Play with Google Native Client. https://developers.google.com/native-client/
* Write Linux kernel driver with Haskell.
* Get smaller RTS. Benchmark the RTS for running on custom FPGA CPU.
* Start rewritng NetBSD kernel with Ajhc.
